{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttPad.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAttPad.RawType
import STD.Deletable.Interface

class (IDeletable a) => ITAttPad a where
        resetAttPad :: (Castable c0 CString) => a -> c0 -> IO ()
        
        setBottomMargin :: () => a -> CFloat -> IO ()
        
        setLeftMargin :: () => a -> CFloat -> IO ()
        
        setRightMargin :: () => a -> CFloat -> IO ()
        
        setTopMargin :: () => a -> CFloat -> IO ()
        
        setMargin ::
                    () => a -> CFloat -> CFloat -> CFloat -> CFloat -> IO ()
        
        setAfile :: () => a -> CFloat -> IO ()
        
        setXfile :: () => a -> CFloat -> IO ()
        
        setYfile :: () => a -> CFloat -> IO ()
        
        setAstat :: () => a -> CFloat -> IO ()
        
        setXstat :: () => a -> CFloat -> IO ()
        
        setYstat :: () => a -> CFloat -> IO ()

upcastTAttPad :: forall a . (FPtr a, ITAttPad a) => a -> TAttPad
upcastTAttPad h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAttPad = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAttPad :: forall a . (FPtr a, ITAttPad a) => TAttPad -> a
downcastTAttPad h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
