{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttText.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAttText.RawType
import STD.Deletable.Interface

class (IDeletable a) => ITAttText a where
        getTextAlign :: () => a -> IO CShort
        
        getTextAngle :: () => a -> IO CFloat
        
        getTextColor :: () => a -> IO CShort
        
        getTextFont :: () => a -> IO CShort
        
        getTextSize :: () => a -> IO CFloat
        
        resetAttText :: (Castable c0 CString) => a -> c0 -> IO ()
        
        setTextAttributes :: () => a -> IO ()
        
        setTextAlign :: () => a -> CShort -> IO ()
        
        setTextAngle :: () => a -> CFloat -> IO ()
        
        setTextColor :: () => a -> CInt -> IO ()
        
        setTextFont :: () => a -> CShort -> IO ()
        
        setTextSize :: () => a -> CFloat -> IO ()
        
        setTextSizePixels :: () => a -> CInt -> IO ()

upcastTAttText :: forall a . (FPtr a, ITAttText a) => a -> TAttText
upcastTAttText h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAttText = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAttText ::
                 forall a . (FPtr a, ITAttText a) => TAttText -> a
downcastTAttText h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
